import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.util.HashSet;
import java.util.Map;
import java.util.HashMap;
import java.util.Collections;

public class Demo {

    public static void main(String[] args) {
        
        Map<Person, Integer> salaries = new HashMap<>();
        
        Person ivan = new Person("Ivan");
        
        salaries.put(new Person("Igor"), 12000);
        salaries.put(new Person("Pavel"), 20000);
        salaries.put(ivan, 18000);
        salaries.put(new Person("Igor"), 25000);
                
        System.out.println("Ivan has salary "+salaries.get(ivan));
    }
}
class Person {
    private String name;
    public Person(String name) { this.name = name; }
    public String toString() { return "Person "+name; }
    
    @Override
    public boolean equals(Object o) {
        if(o instanceof Person) {
            Person p = (Person)o;
            return this.name.equals(p.name);
        } else return false;
    }
    
    @Override
    public int hashCode() {
        return name.hashCode();
    }
}